# -*- ruby -*-

#
# VFS for ruby - open anything with URI
# 
#   Copyright: Tatsuki Sugiura <sugi@nemui.org>
#   License: Ruby's original or GPL2
#   $LastChangedDate: 2003-11-10 23:46:31 +0900 (Mon, 10 Nov 2003) $
#   $LastChangedBy: sugi $ # 

require 'vfs/file'
require 'vfs/dir'
require 'vfs/compat'

# FIXME: must remove this line for stable release.
$DEBUG and VFS.loglevel = VFS::Log::DEBUG

# go override built-in classes
VFS::CompatLayer.permanently = true
VFS::CompatLayer.override

if __FILE__ == $0
#  f = "file:///home/sugi/.bashrc"
  f = "http://localhost/doc/debian/debian-manifesto"
#  f = "http://localhost/~sugi/"
  vfs = VFS::File.new(f)
  p vfs
  p vfs.join(%w(a b c))
  p VFS::join(%w(a b c))
  p VFS::scheme(f)
  p vfs.scheme
  p vfs.mtime
  p VFS::File.mtime(f)
  p VFS::File.atime(f)
  p VFS::File.ctime(f)
  p vfs.basename
  p vfs.dirname
  p vfs.scheme
  io = vfs.open
  puts io.read(20)
  io.close
  vfs.open { |io| puts io.read(20) }
  io = VFS::File.open(f)
  puts io.read(20)
  io.close
  VFS::File.open(f){ |io| puts io.read(20) }
  VFS::File.new("/tmp/moge") << "mogemoge" << Time.new
  open(f){|io|
    io.each_with_index { |line, idx|
      idx < 10 and print "#{idx+1}: #{line}"
    }
  }
end
